<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: Performance</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">


<h1><a class="anchor" id="performance">Performance </a></h1><p>The performance (the speedup in particular) of magpar version 0.1 has been measured on a Compaq SC45 cluster consisting of 11 nodes Alpha Server ES45 with 4 Alpha processors (EV68 @ 1&nbsp;GHz, 8&nbsp;MB Cache/CPU) and 16&nbsp;GB of shared memory each. The nodes are interconnected with a Quadrics switch, which provides a maximum MPI bandwidth of 600&nbsp;MB/s. Since this machine has been shared with several other users, up to 24 processors have been available for speedup measurements.</p>
<p>The speedup has been measured as <em>S<sub>P</sub>=t<sub>1</sub>/t<sub>P</sub></em>, where <em>t<sub>1</sub></em> is the execution time of the program for a given problem on a single processor and <em>t<sub>P</sub></em> is the execution time for the same problem on <em>P</em> processors.</p>
<p>The energy minimization method, which uses the LMVM method of the TAO package, has been applied to calculate the nucleation field of FePt nanoparticles. The timing results are summarized in the following figure:</p>
<div align="center">
<img src="hexagon4.eps.gif" alt="hexagon4.eps.gif"/>
<p><strong>Speedup of initialization, solution, and total execution time of the parallel energy minimization algorithm (TAO) on an AlphaServer.</strong></p></div>
 <table  cellpadding="3" border="1" align="CENTER">
<tr>
<th align="CENTER">processors </th><th align="CENTER">CPU time (h) </th><th align="CENTER">speedup  </th></tr>
<tr>
<th align="CENTER">initialization </th><td align="CENTER">&nbsp; </td><td align="CENTER">&nbsp;  </td></tr>
<tr>
<td align="CENTER">1 </td><td align="CENTER">0.202 </td><td align="CENTER">1.00  </td></tr>
<tr>
<td align="CENTER">4 </td><td align="CENTER">0.080 </td><td align="CENTER">2.52  </td></tr>
<tr>
<td align="CENTER">8 </td><td align="CENTER">0.046 </td><td align="CENTER">4.38  </td></tr>
<tr>
<td align="CENTER">16 </td><td align="CENTER">0.032 </td><td align="CENTER">6.26  </td></tr>
<tr>
<td align="CENTER">20 </td><td align="CENTER">0.027 </td><td align="CENTER">7.33  </td></tr>
<tr>
<td align="CENTER">24 </td><td align="CENTER">0.025 </td><td align="CENTER">7.86  </td></tr>
<tr>
<th align="CENTER">solution </th><td align="CENTER">&nbsp; </td><td align="CENTER">&nbsp;  </td></tr>
<tr>
<td align="CENTER">1 </td><td align="CENTER">5.047 </td><td align="CENTER">1.00  </td></tr>
<tr>
<td align="CENTER">4 </td><td align="CENTER">1.500 </td><td align="CENTER">3.36  </td></tr>
<tr>
<td align="CENTER">8 </td><td align="CENTER">0.568 </td><td align="CENTER">8.87  </td></tr>
<tr>
<td align="CENTER">16 </td><td align="CENTER">0.307 </td><td align="CENTER">16.41  </td></tr>
<tr>
<td align="CENTER">20 </td><td align="CENTER">0.233 </td><td align="CENTER">21.57  </td></tr>
<tr>
<td align="CENTER">24 </td><td align="CENTER">0.210 </td><td align="CENTER">23.97  </td></tr>
<tr>
<th align="CENTER">total </th><td align="CENTER">&nbsp; </td><td align="CENTER">&nbsp;  </td></tr>
<tr>
<td align="CENTER">1 </td><td align="CENTER">5.249 </td><td align="CENTER">1.00  </td></tr>
<tr>
<td align="CENTER">4 </td><td align="CENTER">1.581 </td><td align="CENTER">3.32  </td></tr>
<tr>
<td align="CENTER">8 </td><td align="CENTER">0.615 </td><td align="CENTER">8.53  </td></tr>
<tr>
<td align="CENTER">16 </td><td align="CENTER">0.339 </td><td align="CENTER">15.44  </td></tr>
<tr>
<td align="CENTER">20 </td><td align="CENTER">0.261 </td><td align="CENTER">20.06  </td></tr>
<tr>
<td align="CENTER">24 </td><td align="CENTER">0.236 </td><td align="CENTER">22.20  </td></tr>
</table>
<p>On 8 and 16 processors we find a "superlinear" behavior of the solution part of the application. This is a well known phenomenon in parallel computing and can be attributed to caching effects. As the same total amount of data is distributed over more processors, the relative amount decreases and may reach a size, where it fits into the fast cache memory of modern computer architectures. As a result, the data need not be fetched from the main memory (which is a lot slower than the cache memory) and the calculations are completed a lot faster.</p>
<p>The parallel time integration using PVODE is not as efficiently parallelized as the TAO package, which is shown in the following figure:</p>
<div align="center">
<img src="dot02par_sc2.eps.gif" alt="dot02par_sc2.eps.gif"/>
<p><strong>Speedup of initialization, solution, and total execution time of the parallel time integration (PVODE) on an AlphaServer.</strong></p></div>
 <table  cellpadding="3" border="1" align="CENTER">
<tr>
<th align="CENTER">processors </th><th align="CENTER">CPU time (h) </th><th align="CENTER">speedup  </th></tr>
<tr>
<th align="CENTER">initialization </th><td align="CENTER">&nbsp; </td><td align="CENTER">&nbsp;  </td></tr>
<tr>
<td align="CENTER">1 </td><td align="CENTER">0.255 </td><td align="CENTER">1.00  </td></tr>
<tr>
<td align="CENTER">2 </td><td align="CENTER">0.196 </td><td align="CENTER">1.30  </td></tr>
<tr>
<td align="CENTER">3 </td><td align="CENTER">0.141 </td><td align="CENTER">1.81  </td></tr>
<tr>
<td align="CENTER">6 </td><td align="CENTER">0.080 </td><td align="CENTER">3.19  </td></tr>
<tr>
<td align="CENTER">8 </td><td align="CENTER">0.062 </td><td align="CENTER">4.07  </td></tr>
<tr>
<td align="CENTER">16 </td><td align="CENTER">0.037 </td><td align="CENTER">6.73  </td></tr>
<tr>
<td align="CENTER">20 </td><td align="CENTER">0.032 </td><td align="CENTER">7.96  </td></tr>
<tr>
<th align="CENTER">solution </th><td align="CENTER">&nbsp; </td><td align="CENTER">&nbsp;  </td></tr>
<tr>
<td align="CENTER">1 </td><td align="CENTER">6.309 </td><td align="CENTER">1.00  </td></tr>
<tr>
<td align="CENTER">2 </td><td align="CENTER">3.379 </td><td align="CENTER">1.86  </td></tr>
<tr>
<td align="CENTER">3 </td><td align="CENTER">2.416 </td><td align="CENTER">2.61  </td></tr>
<tr>
<td align="CENTER">6 </td><td align="CENTER">1.120 </td><td align="CENTER">5.63  </td></tr>
<tr>
<td align="CENTER">8 </td><td align="CENTER">0.913 </td><td align="CENTER">6.91  </td></tr>
<tr>
<td align="CENTER">16 </td><td align="CENTER">0.451 </td><td align="CENTER">13.98  </td></tr>
<tr>
<td align="CENTER">20 </td><td align="CENTER">0.393 </td><td align="CENTER">16.03  </td></tr>
<tr>
<th align="CENTER">total </th><td align="CENTER">&nbsp; </td><td align="CENTER">&nbsp;  </td></tr>
<tr>
<td align="CENTER">1 </td><td align="CENTER">6.565 </td><td align="CENTER">1.00  </td></tr>
<tr>
<td align="CENTER">2 </td><td align="CENTER">3.576 </td><td align="CENTER">1.83  </td></tr>
<tr>
<td align="CENTER">3 </td><td align="CENTER">2.557 </td><td align="CENTER">2.56  </td></tr>
<tr>
<td align="CENTER">6 </td><td align="CENTER">1.200 </td><td align="CENTER">5.46  </td></tr>
<tr>
<td align="CENTER">8 </td><td align="CENTER">0.975 </td><td align="CENTER">6.72  </td></tr>
<tr>
<td align="CENTER">16 </td><td align="CENTER">0.489 </td><td align="CENTER">13.42  </td></tr>
<tr>
<td align="CENTER">20 </td><td align="CENTER">0.425 </td><td align="CENTER">15.42  </td></tr>
</table>
<p>For comparison, the next figure shows the speedup obtained on a Beowulf type cluster of 900&nbsp;MHz AMD PCs running Linux (for a different problem). These machines are linked with a standard switched 100&nbsp;MBit Ethernet network.</p>
<div align="center">
<img src="dot02par_a2.eps.gif" alt="dot02par_a2.eps.gif"/>
<p><strong>Speedup of initialization, solution, and total execution time of the parallel time integration (PVODE) on a Beowulf type AMD cluster.</strong></p></div>
 <table  cellpadding="3" border="1" align="CENTER">
<tr>
<th align="CENTER">processors </th><th align="CENTER">CPU time (h) </th><th align="CENTER">speedup  </th></tr>
<tr>
<th align="CENTER">initialization </th><td align="CENTER">&nbsp; </td><td align="CENTER">&nbsp;  </td></tr>
<tr>
<td align="CENTER">1 </td><td align="CENTER">0.075 </td><td align="CENTER">1.00  </td></tr>
<tr>
<td align="CENTER">3 </td><td align="CENTER">0.083 </td><td align="CENTER">0.91  </td></tr>
<tr>
<td align="CENTER">5 </td><td align="CENTER">0.057 </td><td align="CENTER">1.32  </td></tr>
<tr>
<th align="CENTER">solution </th><td align="CENTER">&nbsp; </td><td align="CENTER">&nbsp;  </td></tr>
<tr>
<td align="CENTER">1 </td><td align="CENTER">24.334 </td><td align="CENTER">1.00  </td></tr>
<tr>
<td align="CENTER">3 </td><td align="CENTER">8.5059 </td><td align="CENTER">2.86  </td></tr>
<tr>
<td align="CENTER">5 </td><td align="CENTER">5.8314 </td><td align="CENTER">4.17  </td></tr>
<tr>
<th align="CENTER">total </th><td align="CENTER">&nbsp; </td><td align="CENTER">&nbsp;  </td></tr>
<tr>
<td align="CENTER">1 </td><td align="CENTER">24.41 </td><td align="CENTER">1.00  </td></tr>
<tr>
<td align="CENTER">3 </td><td align="CENTER">8.589 </td><td align="CENTER">2.84  </td></tr>
<tr>
<td align="CENTER">5 </td><td align="CENTER">5.889 </td><td align="CENTER">4.15  </td></tr>
</table>
</div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

